
//***********
//*	%Main.c	*
//***********

//***********************
//*	Define Dialog items	*
//***********************

#define	I_OK		1
#define	I_Cancel	2
#define	I_LocFndr	3
#define	I_Normal	4
#define	I_None		5
#define	I_One8th	6
#define	I_One4th	7
#define	I_OneHalf	8
#define	I_Three4ths	9


//***************
//*	Prototypes	*
//***************

void InitMacToolBox(void);
Boolean TrapAvailable(short TrapID);
void UpdateFinder(void);
short LocateFinder(void);
short DoStopAlert(void);
void HighLightButton(short DlgItem,short HiliteFlag);
void CleanUpFinder(void);

//********************
//* Global Variables *
//********************

short		DType;
short		PrevItem;
short		FndrRefNum;
short		ApplRefNum;
short		SomeThingChanged;
Handle		DItem;
Handle		FndrCodeHdl;
DialogPtr	MainWindow;
Rect		tempRect;
SFReply		Reply;


//********************
//*	Main routine	 *
//********************

main( )
{
short	Done;
short	itemHit;

	//* Init the World
	
	FndrRefNum = -1;
	FndrCodeHdl = NULL;
	SomeThingChanged = FALSE;
	InitMacToolBox( );

	//*	Load & Display Dialog
	
	MainWindow = GetNewDialog( 128, NULL, (WindowPtr)-1 );
	SetPort( MainWindow );
	ShowWindow( MainWindow );
	SelectWindow( MainWindow );
	HighLightButton( I_LocFndr, TRUE );

	//* Wait for something to happen
	
	for( Done = FALSE; !Done; )
	{
		ModalDialog( NULL, &itemHit );
		
		switch( itemHit )
		{
			case I_Cancel:	//* Cancel Button
							Done = TRUE;
							break;

			case I_OK:		//* OK Button
							if( PrevItem )			//* If Finder was opened
							{
								UpdateFinder( );	//*	Update it
								Done = TRUE;		//* Exit
								break;
							}
							//* Drop thru to Finder stuff
										
			case I_LocFndr:	//* Locate the Finder
							if( PrevItem )
							{
								CleanUpFinder( );
								GetDItem( MainWindow, PrevItem, &DType, &DItem, &tempRect );
								SetCtlValue( DItem, 0 );
							}
							HighLightButton( I_LocFndr, FALSE );
							if( (Done = !LocateFinder( )) )
								break;
							HighLightButton( I_OK, TRUE );
							itemHit = PrevItem;
							
							//* Drop Through
							
			case I_Normal:
			case I_None:
			case I_One8th:
			case I_One4th:
			case I_OneHalf:
			case I_Three4ths:	//* Update radio buttons
								if( PrevItem )
								{
									GetDItem( MainWindow, PrevItem, &DType, &DItem, &tempRect );
									SetCtlValue( DItem, 0 );
								}
								PrevItem = itemHit;
								GetDItem( MainWindow, itemHit, &DType, &DItem, &tempRect );
								SetCtlValue( DItem, 1 );
								SomeThingChanged = TRUE;
								break;
		}
	}
	
	//* Release resources and close files
	
	CleanUpFinder( );

	//* Dispose of the dialog and exit
	
	DisposeDialog( MainWindow );
}


//********************
//* Init Mac ToolBox *
//********************

void InitMacToolBox( )
{
EventRecord  myEvent;   				//* Event record for all events

	MaxApplZone( );						//* Expand heap to the max
	MoreMasters( );						//* Want more masters
	MoreMasters( );						//* Want more masters
	MoreMasters( );						//* Want more masters
	MoreMasters( );						//* Want more masters
	InitGraf( &thePort ); 				//* Initialize QuickDraw 
	InitFonts();    					//* Initialize the Font manager
	InitWindows();  					//* Initialize the Window manager
	InitMenus();    					//* Initialize the Menu manager
	TEInit();   						//* Initialize Text Edit
	InitDialogs( NULL );   				//* Initialize the Dialog manager
	InitCursor();   					//* Start with a visible arrow cursor
	FlushEvents(everyEvent,0);  		//* Start with no pending events
	ClearMenuBar(); 					//* Clear any old menu bars
 	ApplRefNum = CurResFile( );			//* Get our RefNum
 	
	EventAvail( everyEvent, &myEvent );	//* Check for a couple of Events
	EventAvail( everyEvent, &myEvent );	//* Check for a couple of Events
}


//******************************************
//* Locate Finder button pressed - do it ! *
//******************************************

short LocateFinder( )
{
Point	Where;
long	FileList[4];
register short	*FndrCode;

	FileList[0] = 'FNDR';		//* Only want Finder files
	Where.v = Where.h = 80;		//* Draw the dialog here

	SFPGetFile( Where, "\p", NULL, 1, FileList, NULL, &Reply, 4000, NULL );
	
	//* Check for Cancel button
	
	if( !Reply.good )
		return( FALSE );
	
	//* Open the Finder
	
	if( (FndrRefNum = OpenRFPerm( Reply.fName, Reply.vRefNum, fsRdWrPerm )) == -1 )
		return( FALSE );
	
	//* Load the CODE resource we need
	
	if( (FndrCodeHdl = Get1Resource( 'CODE', 11 )) == NULL )
		return( DoStopAlert( ) );
	
	//* Lock it and get the Offset we need
	
	HLock( FndrCodeHdl );
	FndrCode = (short *)((*FndrCodeHdl) + 0x9F8);
	
	//* Validate some Finder code in order to make sure we have the right file
	
	if( FndrCode[0] != 0x1D7C || FndrCode[1] != 0x0001 || 
		FndrCode[2] != 0xFFB9 || FndrCode[6] != 0xD880 )
			return( DoStopAlert( ) );
	
	//* Check for Virgin Finder
	
	if( FndrCode[3] == 0x2038 && FndrCode[4] == 0x02F0 && FndrCode[5] == 0xE388 )
	{
		PrevItem = I_Normal;
		return( TRUE );
	}
	
	//* Check for Modified Finder
	
	if( FndrCode[4] != 0x4E71 || FndrCode[5] != 0x4E71 )
		return( DoStopAlert( ) );
	
	if( FndrCode[3] == 0x7000 )			//* If modified, is it 'No Delay' ?
		PrevItem = I_None;
	else
		if( FndrCode[3] == 0x7005 )		//* Is it 1/8th Delay ?
			PrevItem = I_One8th;
	else
		if( FndrCode[3] == 0x700A )		//* Is it 1/4 Delay ?
			PrevItem = I_One4th;
	else
		if( FndrCode[3] == 0x7014 )		//* Is it 1/2 Delay ?
			PrevItem = I_OneHalf;
	else
		if( FndrCode[3] == 0x701E )		//* Is it 3/4 Delay ?
			PrevItem = I_Three4ths;
	else
		return( DoStopAlert( ) );		//* None of the above,,must be an error !
	
	return( TRUE );
}




void UpdateFinder( )
{
register short	*FndrCode;

	//* Must have a Radio button selected, an open Finder file, a loaded
	//* CODE resource and the delay must have been changed.

	if( !PrevItem || FndrRefNum <= 0 || !FndrCodeHdl || !SomeThingChanged )
		return;
	
	//* Get the offset to the Code we want
	
	FndrCode = (short *)((*FndrCodeHdl) + 0x9F8);

	//* Modify the Finder code according to the selected radio button
	
	switch( PrevItem )
	{
		case I_Normal:		FndrCode[3] = 0x2038;	//*	move.l	DoubleTime,d0
							FndrCode[4] = 0x02F0;
							FndrCode[5] = 0xE388;	//*	lsl.l	#1,d0
							break;
							
		case I_None:		FndrCode[3] = 0x7000;	//*	moveq	#0,d0
							FndrCode[4] = 0x4E71;	//*	nop
							FndrCode[5] = 0x4E71;	//*	nop
							break;
							
		case I_One8th:		FndrCode[3] = 0x7005;	//*	moveq	#5,d0
							FndrCode[4] = 0x4E71;	//*	nop
							FndrCode[5] = 0x4E71;	//*	nop
							break;
							
		case I_One4th:		FndrCode[3] = 0x700A;	//*	moveq	#10,d0
							FndrCode[4] = 0x4E71;	//*	nop
							FndrCode[5] = 0x4E71;	//*	nop
							break;
							
		case I_OneHalf:		FndrCode[3] = 0x7014;	//*	moveq	#20,d0
							FndrCode[4] = 0x4E71;	//*	nop
							FndrCode[5] = 0x4E71;	//*	nop
							break;
							
		case I_Three4ths:	FndrCode[3] = 0x701E;	//*	moveq	#30,d0
							FndrCode[4] = 0x4E71;	//*	nop
							FndrCode[5] = 0x4E71;	//*	nop
							break;
		
		default:			return;
	}
	
	//* Write the modified CODE resource back out and exit
	
	ChangedResource( FndrCodeHdl );
	WriteResource( FndrCodeHdl );
	UpdateResFile( FndrRefNum );
}




short DoStopAlert( )
{
short		OldResFile;
GrafPtr		OldPort;

	GetPort( &OldPort );
	OldResFile = CurResFile( );
	UseResFile( ApplRefNum );

	StopAlert( 128, NULL );
	
	UseResFile( OldResFile );
	SetPort( OldPort );
	return( FALSE );
}



void HighLightButton( DlgItem, HiliteFlag )
short	DlgItem;
short	HiliteFlag;
{
	if( !HiliteFlag )
		PenMode( patXor );
	GetDItem( MainWindow, DlgItem, &DType, &DItem, &tempRect );
	InsetRect( &tempRect, -4, -4 );
	PenSize( 3, 3 );
	FrameRoundRect( &tempRect, 16, 16 );
	PenNormal( );
	if( HiliteFlag )
		((DialogPeek)MainWindow)->aDefItem = DlgItem;
}



void CleanUpFinder( )
{
	//* If we have a CODE resource loaded, release it
	
	if( FndrCodeHdl )
		ReleaseResource( FndrCodeHdl );
	FndrCodeHdl = NULL;
	
	//* If we have the Finder open, close it
	
	if( FndrRefNum > 0 )
		CloseResFile( FndrRefNum );
	FndrRefNum = 0;
	
	PrevItem = 0;
}




